"""
B-ASIC test suite for Inputport
"""

# import module we are testing
from b_asic import InputPort

# import dependencies
from b_asic import Signal, SignalSource, SignalDestination, Addition

import pytest

def test_connect_multiple_signals(signals):
    """
    test if only one signal can connect to an input port
    """
    inp_port = InputPort(0)

    for s in signals:
        inp_port.connect(s)

    assert inp_port.signal_count() == 1
    assert inp_port.signals()[0] == signals[-1]